#!/usr/bin/env node
import { I as c, S as E } from "./index-a1ee6691.js";
import { log as o, _get as I, initHandlerCommon as k, getConfigFileCommonOptions as A, _set as w, readConfigFile as T, createSubcommand as N, getRootScriptName as _, createMainCommand as M } from "@done-coding/cli-utils";
import $ from "node:path";
import u from "node:fs";
const x = ({
  sourceJson: e,
  targetKey: n,
  keyConfig: t
}) => {
  let s;
  typeof t == "string" ? s = {
    type: c.FIXED,
    value: t
  } : s = t;
  const { type: a = c.READ } = s;
  switch (a) {
    case c.REG: {
      const { sourceKey: r, pattern: f, replaceValue: p, flags: g } = s, y = new RegExp(f, g ?? void 0), i = I(e, r);
      return typeof i == "string" ? i.replace(y, p) : (o.warn(
        `${i}不是字符串类型，无法使用正则表达式进行替换，此处将直接返回原值`
      ), i);
    }
    case c.FIXED: {
      const { value: r } = s;
      return r;
    }
    case c.READ: {
      const { sourceKey: r = n } = s;
      return I(e, r);
    }
    default: {
      o.warn(`未知的配置类型${a}`);
      return;
    }
  }
}, d = {
  name: "@done-coding/cli-inject",
  version: "0.5.14",
  description: "信息(JSON)注入命令行工具",
  bin: {
    "dc-inject": "es/cli.mjs"
  },
  cliConfig: {
    namespaceDir: ".done-coding",
    moduleName: "inject"
  }
}, {
  cliConfig: { namespaceDir: G, moduleName: J }
} = d, L = `./${G}/${J}`, R = `${L}.json`, h = {
  sourceFilePath: "./package.json",
  keyConfigMap: {
    name: {
      type: c.READ
    },
    version: {
      type: c.READ
    },
    description: {
      type: c.READ
    },
    bin: {
      type: c.READ
    }
  },
  injectFilePath: "./src/injectInfo.json"
}, U = () => A({
  configPathDefault: R
}), S = async (e) => k(h, e, {
  onFileGenerated: () => {
    o.info("文件生成成功");
  }
}), V = {
  command: E.INIT,
  describe: "初始化配置文件",
  options: U(),
  handler: S
}, H = () => ({
  ...A({
    configPathDefault: R
  })
}), K = async ({
  rootDir: e = process.cwd(),
  config: n = h,
  keyConfigMap: t = {}
} = {}) => {
  const {
    sourceFilePath: s,
    keyConfigMap: a,
    injectFilePath: r
  } = n, f = {
    ...a,
    ...t
  };
  if (!s.endsWith(".json"))
    return o.error("源文件必须是json"), process.exit(1);
  if (!r.endsWith(".json"))
    return o.error("注入文件必须是json"), process.exit(1);
  const p = $.resolve(e, s), g = u.readFileSync(p, "utf-8"), y = JSON.parse(g), i = Object.entries(f).reduce(
    (m, [F, v]) => {
      const P = x({ sourceJson: y, targetKey: F, keyConfig: v });
      return w(m, F, P), m;
    },
    {}
  ), l = $.resolve(e, r), C = JSON.stringify(i, null, 2);
  if (u.existsSync(l)) {
    const m = u.readFileSync(l, "utf-8");
    if (C === m)
      return o.skip("注入文件已存在且内容相同，无需重复注入"), i;
    o.stage("文件内容变化,开始覆盖注入文件");
  } else
    o.stage("开始注入文件");
  u.writeFileSync(l, C), o.success(`文件注入成功: ${l}`), o.info(C);
}, j = async (e) => {
  const n = await T(e, () => (o.info("配置文件为空，使用默认配置"), h));
  if (!n)
    return o.error("配置文件为空"), process.exit(1);
  const { rootDir: t } = e;
  await K({ rootDir: t, config: n });
}, W = {
  command: "$0",
  describe: "生成文件",
  options: H(),
  handler: j
}, Z = async (e, n) => {
  switch (e) {
    case E.INIT:
      return S(n);
    case E.GENERATE:
      return j(n);
    default:
      return j(n);
  }
}, { version: X, description: q } = d, b = {
  describe: q,
  version: X,
  subcommands: [V, W].map(
    N
  ),
  demandCommandCount: 1,
  rootScriptName: _({ packageJson: d })
}, {
  cliConfig: { moduleName: D }
} = d, O = (e = !1) => {
  const n = e ? D : void 0, t = `$0${e ? ` ${D}` : ""} <command> [options]`;
  return { command: n, usage: t };
}, ee = async () => M({
  ...b,
  ...O()
}), ne = () => N({
  ...b,
  ...O(!0)
});
export {
  ne as a,
  V as b,
  ee as c,
  j as d,
  W as e,
  Z as f,
  K as g,
  S as h,
  b as i,
  x as k
};
